Index: smf/Sources/Profile.php
===================================================================
--- smf/Sources/Profile.php	(revision 1047)
+++ smf/Sources/Profile.php	(working copy)
@@ -5,9 +5,9 @@
 * SMF: Simple Machines Forum                                                      *
 * Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                    *
 * =============================================================================== *
-* Software Version:           SMF 1.1.5                                           *
+* Software Version:           SMF 1.1.10                                          *
 * Software by:                Simple Machines (http://www.simplemachines.org)     *
-* Copyright 2006-2007 by:     Simple Machines LLC (http://www.simplemachines.org) *
+* Copyright 2006-2009 by:     Simple Machines LLC (http://www.simplemachines.org) *
 *           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
 * Support, News, Updates at:  http://www.simplemachines.org                       *
 ***********************************************************************************
@@ -699,7 +699,8 @@
 			// Prepare the new password, or check if they want to change their own.
 			if (!empty($modSettings['send_validation_onChange']) && !allowedTo('moderate_forum'))
 			{
-				$validationCode = substr(preg_replace('/\W/', '', md5(rand())), 0, 10);
+				require_once($sourcedir . '/Subs-Members.php');
+				$validationCode = generateValidationCode();
 				$profile_vars['validation_code'] = '\'' . $validationCode . '\'';
 				$profile_vars['is_activated'] = '2';
 				$newpassemail = true;
@@ -901,6 +902,29 @@
 {
 	global $db_prefix, $modSettings;
 
+	$reservedVars = array(
+		'actual_theme_url',
+		'actual_images_url',
+		'base_theme_dir',
+		'base_theme_url',
+		'default_images_url',
+		'default_theme_dir',
+		'default_theme_url',
+		'default_template',
+		'images_url',
+		'number_recent_posts',
+		'smiley_sets_default',
+		'theme_dir',
+		'theme_id',
+		'theme_layers',
+		'theme_templates',
+		'theme_url',
+	);
+
+	// Can't change reserved vars.
+	if ((isset($_POST['options']) && array_intersect(array_keys($_POST['options']), $reservedVars) != array()) || (isset($_POST['default_options']) && array_intersect(array_keys($_POST['default_options']), $reservedVars) != array()))
+		fatal_lang_error(1);
+
 	// These are the theme changes...
 	$themeSetArray = array();
 	if (isset($_POST['options']) && is_array($_POST['options']))
@@ -1090,6 +1114,24 @@
 			}
 			elseif (is_array($sizes))
 			{
+				// Though not an exhaustive list, better safe than sorry.
+				$fp = fopen($_FILES['attachment']['tmp_name'], 'rb');
+				if (!$fp)
+					fatal_lang_error('smf124');
+
+				// Now try to find an infection.
+				while (!feof($fp))
+				{
+					if (preg_match('~(iframe|\\<\\?php|\\<\\?[\s=]|\\<%[\s=]|html|eval|body|script\W)~', fgets($fp, 4096)) === 1)
+					{
+						if (file_exists($uploadDir . '/avatar_tmp_' . $memID))
+							@unlink($uploadDir . '/avatar_tmp_' . $memID);
+
+						fatal_lang_error('smf124');
+					}
+				}
+				fclose($fp);
+
 				$extensions = array(
 					'1' => '.gif',
 					'2' => '.jpg',
@@ -1104,16 +1146,28 @@
 				// Remove previous attachments this member might have had.
 				removeAttachments('a.ID_MEMBER = ' . $memID);
 
-				if (!rename($_FILES['attachment']['tmp_name'], $uploadDir . '/' . $destName))
-					fatal_lang_error('smf124');
+				$file_hash = empty($modSettings['custom_avatar_enabled']) ? getAttachmentFilename($destName, false, true) : '';
 
 				db_query("
 					INSERT INTO {$db_prefix}attachments
-						(ID_MEMBER, attachmentType, filename, size, width, height)
-					VALUES ($memID, " . (empty($modSettings['custom_avatar_enabled']) ? '0' : '1') . ", '$destName', " . filesize($uploadDir . '/' . $destName) . ", " . (int) $width . ", " . (int) $height . ")", __FILE__, __LINE__);
+						(ID_MEMBER, attachmentType, filename, file_hash, size, width, height)
+					VALUES ($memID, " . (empty($modSettings['custom_avatar_enabled']) ? '0' : '1') . ", '$destName', '" . (empty($file_hash) ? "" : "$file_hash") . "', " . filesize($_FILES['attachment']['tmp_name']) . ", " . (int) $width . ", " . (int) $height . ")", __FILE__, __LINE__);
+				$attachID = db_insert_id();
 
+				// Try to move this avatar.
+				$destinationPath = $uploadDir . '/' . (empty($file_hash) ? $destName : $attachID . '_' . $file_hash);
+				if (!rename($_FILES['attachment']['tmp_name'], $destinationPath))
+				{
+					// The move failed, get rid of it and die.
+					db_query("
+						DELETE FROM {$db_prefix}attachments
+						WHERE ID_ATTACH = $attachID", __FILE__, __LINE__);
+
+					fatal_lang_error('smf124');
+				}
+
 				// Attempt to chmod it.
-				@chmod($uploadDir . '/' . $destName, 0644);
+				@chmod($destinationPath, 0644);
 			}
 			$_POST['avatar'] = '';
 
@@ -1202,7 +1256,7 @@
 		$context['activate_link_text'] = in_array($context['member']['is_activated'], array(3, 4, 5, 13, 14, 15)) ? $txt['account_approve'] : $txt['account_activate'];
 
 		// Should we show a custom message?
-		$context['activate_message'] = isset($txt['account_activate_method_' . $context['member']['is_activated'] % 10]) ? $txt['account_activate_method_' . $context['member']['is_activated']] : $txt['account_not_activated'];
+		$context['activate_message'] = isset($txt['account_activate_method_' . $context['member']['is_activated'] % 10]) ? $txt['account_activate_method_' . $context['member']['is_activated'] % 10] : $txt['account_not_activated'];
 	}
 
 	// How about, are they banned?
@@ -1854,8 +1908,10 @@
 	// Get some totals for pagination.
 	$request = db_query("
 		SELECT COUNT(*)
-		FROM {$db_prefix}messages
-		WHERE posterIP $dbip", __FILE__, __LINE__);
+		FROM {$db_prefix}messages AS m
+			INNER JOIN {$db_prefix}boards AS b ON (b.ID_BOARD = m.ID_BOARD)
+		WHERE $user_info[query_see_board]
+			AND m.posterIP $dbip", __FILE__, __LINE__);
 	list ($totalMessages) = mysql_fetch_row($request);
 	mysql_free_result($request);
 	$request = db_query("
@@ -1887,8 +1943,10 @@
 			m.ID_MSG, m.posterIP, IFNULL(mem.realName, m.posterName) AS display_name, mem.ID_MEMBER,
 			m.subject, m.posterTime, m.ID_TOPIC, m.ID_BOARD
 		FROM {$db_prefix}messages AS m
+			INNER JOIN {$db_prefix}boards AS b ON (b.ID_BOARD = m.ID_BOARD)
 			LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER = m.ID_MEMBER)
-		WHERE m.posterIP $dbip
+		WHERE $user_info[query_see_board]
+			AND m.posterIP $dbip
 		ORDER BY m.ID_MSG DESC
 		LIMIT $context[message_start], 20", __FILE__, __LINE__);
 	$context['messages'] = array();
@@ -1950,12 +2008,12 @@
 			),
 			'apnic' => array(
 				'name' => &$txt['whois_apnic'],
-				'url' => 'http://www.apnic.net/apnic-bin/whois2.pl?searchtext=' . $context['ip'],
+				'url' => 'http://wq.apnic.net/apnic-bin/whois.pl?searchtext=' . $context['ip'],
 				'range' => array(58, 59, 60, 61, 124, 125, 126, 202, 203, 210, 211, 218, 219, 220, 221, 222),
 			),
 			'arin' => array(
 				'name' => &$txt['whois_arin'],
-				'url' => 'http://ws.arin.net/cgi-bin/whois.pl?queryinput=' . $context['ip'],
+				'url' => 'http://ws.arin.net/whois/?queryinput=' . $context['ip'],
 				'range' => array(63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 199, 204, 205, 206, 207, 208, 209, 216),
 			),
 			'lacnic' => array(
@@ -1965,7 +2023,7 @@
 			),
 			'ripe' => array(
 				'name' => &$txt['whois_ripe'],
-				'url' => 'http://www.ripe.net/perl/whois?searchtext=' . $context['ip'],
+				'url' => 'http://www.db.ripe.net/whois?searchtext=' . $context['ip'],
 				'range' => array(62, 80, 81, 82, 83, 84, 85, 86, 87, 88, 193, 194, 195, 212, 213, 217),
 			),
 		);
Index: smf/Sources/QueryString.php
===================================================================
--- smf/Sources/QueryString.php	(revision 1047)
+++ smf/Sources/QueryString.php	(working copy)
@@ -5,9 +5,9 @@
 * SMF: Simple Machines Forum                                                      *
 * Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                    *
 * =============================================================================== *
-* Software Version:           SMF 1.1.5                                           *
+* Software Version:           SMF 1.1.9                                           *
 * Software by:                Simple Machines (http://www.simplemachines.org)     *
-* Copyright 2006 by:          Simple Machines LLC (http://www.simplemachines.org) *
+* Copyright 2006-2009 by:     Simple Machines LLC (http://www.simplemachines.org) *
 *           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
 * Support, News, Updates at:  http://www.simplemachines.org                       *
 ***********************************************************************************
@@ -120,7 +120,7 @@
 
 		// Replace ';' with '&' and '&something&' with '&something=&'.  (this is done for compatibility...)
 		// !!! smflib
-		parse_str(preg_replace('/&(\w+)(?=&|$)/', '&$1=', strtr($_SERVER['QUERY_STRING'], array(';?' => '&', ';' => '&'))), $_GET);
+		parse_str(preg_replace('/&(\w+)(?=&|$)/', '&$1=', strtr($_SERVER['QUERY_STRING'], array(';?' => '&', ';' => '&', '%00' => '', "\0" => ''))), $_GET);
 	}
 	elseif (strpos(@ini_get('arg_separator.input'), ';') !== false)
 	{
@@ -252,15 +252,15 @@
 	$_SERVER['BAN_CHECK_IP'] = isset($_SERVER['REMOTE_ADDR']) && preg_match('~^((([1]?\d)?\d|2[0-4]\d|25[0-5])\.){3}(([1]?\d)?\d|2[0-4]\d|25[0-5])$~', $_SERVER['REMOTE_ADDR']) === 1 ? $_SERVER['REMOTE_ADDR'] : 'unknown';
 
 	// Find the user's IP address. (but don't let it give you 'unknown'!)
-	if (!empty($_SERVER['HTTP_X_FORWARDED_FOR']) && !empty($_SERVER['HTTP_CLIENT_IP']) && (preg_match('~^((0|10|172\.16|192\.168|255|127\.0)\.|unknown)~', $_SERVER['HTTP_CLIENT_IP']) == 0 || preg_match('~^((0|10|172\.16|192\.168|255|127\.0)\.|unknown)~', $_SERVER['REMOTE_ADDR']) != 0))
+	if (!empty($_SERVER['HTTP_X_FORWARDED_FOR']) && !empty($_SERVER['HTTP_CLIENT_IP']) && (preg_match('~^((0|10|172\.(1[6-9]|2[0-9]|3[01])|192\.168|255|127)\.|unknown)~', $_SERVER['HTTP_CLIENT_IP']) == 0 || preg_match('~^((0|10|172\.(1[6-9]|2[0-9]|3[01])|192\.168|255|127)\.|unknown)~', $_SERVER['REMOTE_ADDR']) != 0))
 	{
 		// We have both forwarded for AND client IP... check the first forwarded for as the block - only switch if it's better that way.
-		if (strtok($_SERVER['HTTP_X_FORWARDED_FOR'], '.') != strtok($_SERVER['HTTP_CLIENT_IP'], '.') && '.' . strtok($_SERVER['HTTP_X_FORWARDED_FOR'], '.') == strrchr($_SERVER['HTTP_CLIENT_IP'], '.') && (preg_match('~^((0|10|172\.16|192\.168|255|127\.0)\.|unknown)~', $_SERVER['HTTP_X_FORWARDED_FOR']) == 0 || preg_match('~^((0|10|172\.16|192\.168|255|127\.0)\.|unknown)~', $_SERVER['REMOTE_ADDR']) != 0))
+		if (strtok($_SERVER['HTTP_X_FORWARDED_FOR'], '.') != strtok($_SERVER['HTTP_CLIENT_IP'], '.') && '.' . strtok($_SERVER['HTTP_X_FORWARDED_FOR'], '.') == strrchr($_SERVER['HTTP_CLIENT_IP'], '.') && (preg_match('~^((0|10|172\.(1[6-9]|2[0-9]|3[01])|192\.168|255|127)\.|unknown)~', $_SERVER['HTTP_X_FORWARDED_FOR']) == 0 || preg_match('~^((0|10|172\.(1[6-9]|2[0-9]|3[01])|192\.168|255|127)\.|unknown)~', $_SERVER['REMOTE_ADDR']) != 0))
 			$_SERVER['REMOTE_ADDR'] = implode('.', array_reverse(explode('.', $_SERVER['HTTP_CLIENT_IP'])));
 		else
 			$_SERVER['REMOTE_ADDR'] = $_SERVER['HTTP_CLIENT_IP'];
 	}
-	if (!empty($_SERVER['HTTP_CLIENT_IP']) && (preg_match('~^((0|10|172\.16|192\.168|255|127\.0)\.|unknown)~', $_SERVER['HTTP_CLIENT_IP']) == 0 || preg_match('~^((0|10|172\.16|192\.168|255|127\.0)\.|unknown)~', $_SERVER['REMOTE_ADDR']) != 0))
+	if (!empty($_SERVER['HTTP_CLIENT_IP']) && (preg_match('~^((0|10|172\.(1[6-9]|2[0-9]|3[01])|192\.168|255|127)\.|unknown)~', $_SERVER['HTTP_CLIENT_IP']) == 0 || preg_match('~^((0|10|172\.(1[6-9]|2[0-9]|3[01])|192\.168|255|127)\.|unknown)~', $_SERVER['REMOTE_ADDR']) != 0))
 	{
 		// Since they are in different blocks, it's probably reversed.
 		if (strtok($_SERVER['REMOTE_ADDR'], '.') != strtok($_SERVER['HTTP_CLIENT_IP'], '.'))
@@ -279,7 +279,7 @@
 			foreach ($ips as $i => $ip)
 			{
 				// Make sure it's in a valid range...
-				if (preg_match('~^((0|10|172\.16|192\.168|255|127\.0)\.|unknown)~', $ip) != 0 && preg_match('~^((0|10|172\.16|192\.168|255|127\.0)\.|unknown)~', $_SERVER['REMOTE_ADDR']) == 0)
+				if (preg_match('~^((0|10|172\.(1[6-9]|2[0-9]|3[01])|192\.168|255|127)\.|unknown)~', $ip) != 0 && preg_match('~^((0|10|172\.(1[6-9]|2[0-9]|3[01])|192\.168|255|127)\.|unknown)~', $_SERVER['REMOTE_ADDR']) == 0)
 					continue;
 
 				// Otherwise, we've got an IP!
@@ -288,7 +288,7 @@
 			}
 		}
 		// Otherwise just use the only one.
-		elseif (preg_match('~^((0|10|172\.16|192\.168|255|127\.0)\.|unknown)~', $_SERVER['HTTP_X_FORWARDED_FOR']) == 0 || preg_match('~^((0|10|172\.16|192\.168|255|127\.0)\.|unknown)~', $_SERVER['REMOTE_ADDR']) != 0)
+		elseif (preg_match('~^((0|10|172\.(1[6-9]|2[0-9]|3[01])|192\.168|255|127)\.|unknown)~', $_SERVER['HTTP_X_FORWARDED_FOR']) == 0 || preg_match('~^((0|10|172\.(1[6-9]|2[0-9]|3[01])|192\.168|255|127)\.|unknown)~', $_SERVER['REMOTE_ADDR']) != 0)
 			$_SERVER['REMOTE_ADDR'] = $_SERVER['HTTP_X_FORWARDED_FOR'];
 	}
 	elseif (!isset($_SERVER['REMOTE_ADDR']))
Index: smf/Sources/Register.php
===================================================================
--- smf/Sources/Register.php	(revision 1047)
+++ smf/Sources/Register.php	(working copy)
@@ -5,9 +5,9 @@
 * SMF: Simple Machines Forum                                                      *
 * Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                    *
 * =============================================================================== *
-* Software Version:           SMF 1.1.5                                           *
+* Software Version:           SMF 1.1.10                                          *
 * Software by:                Simple Machines (http://www.simplemachines.org)     *
-* Copyright 2006-2007 by:     Simple Machines LLC (http://www.simplemachines.org) *
+* Copyright 2006-2009 by:     Simple Machines LLC (http://www.simplemachines.org) *
 *           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
 * Support, News, Updates at:  http://www.simplemachines.org                       *
 ***********************************************************************************
@@ -119,7 +119,7 @@
 	if ($context['visual_verification'])
 	{
 		$context['use_graphic_library'] = in_array('gd', get_loaded_extensions());
-		$context['verificiation_image_href'] = $scripturl . '?action=verificationcode;rand=' . md5(rand());
+		$context['verificiation_image_href'] = $scripturl . '?action=verificationcode;rand=' . md5(mt_rand());
 
 		// Only generate a new code if one hasn't been set yet
 		if (!isset($_SESSION['visual_verification_code']))
@@ -217,7 +217,7 @@
 	if (isset($_POST['realName']) && (!empty($modSettings['allow_editDisplayName']) || allowedTo('moderate_forum')))
 	{
 		$_POST['realName'] = trim(preg_replace('~[\s]~' . ($context['utf8'] ? 'u' : ''), ' ', $_POST['realName']));
-		if (trim($_POST['realName']) != '' && !isReservedName($_POST['realName'], $memID) && $func['strlen']($_POST['realName']) <= 60)
+		if (trim($_POST['realName']) != '' && !isReservedName($_POST['realName']) && $func['strlen']($_POST['realName']) <= 60)
 			$possible_strings[] = 'realName';
 	}
 
@@ -298,7 +298,7 @@
 	// Registration options are always default options...
 	if (isset($_POST['default_options']))
 		$_POST['options'] = isset($_POST['options']) ? $_POST['options'] + $_POST['default_options'] : $_POST['default_options'];
-	$regOptions['theme_vars'] = isset($_POST['options']) && is_array($_POST['options']) ? $_POST['options'] : array();
+	$regOptions['theme_vars'] = isset($_POST['options']) && is_array($_POST['options']) ? htmlspecialchars__recursive($_POST['options']) : array();
 
 	$memberID = registerMember($regOptions);
 
@@ -543,7 +543,7 @@
 		loadLanguage('Login');
 		loadTemplate('Register');
 
-		$context['verificiation_sound_href'] = $scripturl . '?action=verificationcode;rand=' . md5(rand()) . ';format=.wav';
+		$context['verificiation_sound_href'] = $scripturl . '?action=verificationcode;rand=' . md5(mt_rand()) . ';format=.wav';
 		$context['sub_template'] = 'verification_sound';
 		$context['template_layers'] = array();
 
Index: smf/Sources/Reminder.php
===================================================================
--- smf/Sources/Reminder.php	(revision 1047)
+++ smf/Sources/Reminder.php	(working copy)
@@ -5,7 +5,7 @@
 * SMF: Simple Machines Forum                                                      *
 * Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                    *
 * =============================================================================== *
-* Software Version:           SMF 1.1.2                                           *
+* Software Version:           SMF 1.1.6                                           *
 * Software by:                Simple Machines (http://www.simplemachines.org)     *
 * Copyright 2006-2007 by:     Simple Machines LLC (http://www.simplemachines.org) *
 *           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
@@ -120,7 +120,8 @@
 		fatal_error('<b>' . $txt[394] . '<br />' . $txt[395] . ' <a href="mailto:' . $webmaster_email . '">webmaster</a> ' . $txt[396] . '.');
 
 	// Randomly generate a new password, with only alpha numeric characters that is a max length of 10 chars.
-	$password = substr(preg_replace('/\W/', '', md5(rand())), 0, 10);
+	require_once($sourcedir . '/Subs-Members.php');
+	$password = generateValidationCode();
 
 	// Set the password in the database.
 	updateMemberData($row['ID_MEMBER'], array('validation_code' => "'" . substr(md5($password), 0, 10) . "'"));
Index: smf/Sources/Security.php
===================================================================
--- smf/Sources/Security.php	(revision 1047)
+++ smf/Sources/Security.php	(working copy)
@@ -5,9 +5,9 @@
 * SMF: Simple Machines Forum                                                      *
 * Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                    *
 * =============================================================================== *
-* Software Version:           SMF 1.1.5                                           *
+* Software Version:           SMF 1.1.9                                           *
 * Software by:                Simple Machines (http://www.simplemachines.org)     *
-* Copyright 2006 by:          Simple Machines LLC (http://www.simplemachines.org) *
+* Copyright 2006-2009 by:     Simple Machines LLC (http://www.simplemachines.org) *
 *           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
 * Support, News, Updates at:  http://www.simplemachines.org                       *
 ***********************************************************************************
@@ -193,7 +193,6 @@
 
 	// Use the kick_guest sub template...
 	$context['kick_message'] = $message;
-	$context['sub_template'] = 'kick_guest';
 	$context['page_title'] = $txt[34];
 
 	obExit();
@@ -607,6 +606,22 @@
 	trigger_error('Hacking attempt...', E_USER_ERROR);
 }
 
+function checkConfirm($action)
+{
+	global $modSettings;
+	
+	if (isset($_GET['confirm']) && isset($_SESSION['confirm_' . $action]) && md5($_GET['confirm'] . $_SERVER['HTTP_USER_AGENT']) == $_SESSION['confirm_' . $action])
+		return true;
+		
+	else
+	{
+		$token = md5(mt_rand() . session_id() . (string) microtime() . $modSettings['rand_seed']);
+		$_SESSION['confirm_' . $action] = md5($token . $_SERVER['HTTP_USER_AGENT']);
+		
+		return $token;
+	}
+}
+
 // Check whether a form has been submitted twice.
 function checkSubmitOnce($action, $is_fatal = true)
 {
@@ -620,7 +635,7 @@
 	{
 		$context['form_sequence_number'] = 0;
 		while (empty($context['form_sequence_number']) || in_array($context['form_sequence_number'], $_SESSION['forms']))
-			$context['form_sequence_number'] = rand(1, 16000000);
+			$context['form_sequence_number'] = mt_rand(1, 16000000);
 	}
 	// Check whether the submitted number can be found in the session.
 	elseif ($action == 'check')
@@ -638,7 +653,7 @@
 			return false;
 	}
 	// Don't check, just free the stack number.
-	elseif ($action == 'free' && isset($_REQUEST['seqnum']) && in_array($_REQUEST['seqnum'], $_SESSION['forms']))	
+	elseif ($action == 'free' && isset($_REQUEST['seqnum']) && in_array($_REQUEST['seqnum'], $_SESSION['forms']))
 		$_SESSION['forms'] = array_diff($_SESSION['forms'], array($_REQUEST['seqnum']));
 	elseif ($action != 'free')
 		trigger_error('checkSubmitOnce(): Invalid action \'' . $action . '\'', E_USER_WARNING);
Index: smf/Sources/SplitTopics.php
===================================================================
--- smf/Sources/SplitTopics.php	(revision 1047)
+++ smf/Sources/SplitTopics.php	(working copy)
@@ -5,7 +5,7 @@
 * SMF: Simple Machines Forum                                                      *
 * Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                    *
 * =============================================================================== *
-* Software Version:           SMF 1.1.2                                           *
+* Software Version:           SMF 1.1.6                                           *
 * Software by:                Simple Machines (http://www.simplemachines.org)     *
 * Copyright 2006-2007 by:     Simple Machines LLC (http://www.simplemachines.org) *
 *           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
@@ -626,6 +626,10 @@
 	$_REQUEST['targetboard'] = isset($_REQUEST['targetboard']) ? (int) $_REQUEST['targetboard'] : $board;
 	$context['target_board'] = $_REQUEST['targetboard'];
 
+	if (!isset($_GET['from']))
+		fatal_lang_error(1);
+	$_GET['from'] = (int) $_GET['from'];
+
 	// How many topics are on this board?  (used for paging.)
 	$request = db_query("
 		SELECT COUNT(*)
@@ -728,7 +732,7 @@
 
 	// Handle URLs from MergeIndex.
 	if (!empty($_GET['from']) && !empty($_GET['to']))
-		$topics = array($_GET['from'], $_GET['to']);
+		$topics = array((int) $_GET['from'], (int) $_GET['to']);
 
 	// If we came from a form, the topic IDs came by post.
 	if (!empty($_POST['topics']) && is_array($_POST['topics']))
@@ -1091,8 +1095,8 @@
 	global $txt, $context;
 
 	// Make sure the template knows everything...
-	$context['target_board'] = $_GET['targetboard'];
-	$context['target_topic'] = $_GET['to'];
+	$context['target_board'] = (int) $_GET['targetboard'];
+	$context['target_topic'] = (int) $_GET['to'];
 
 	$context['page_title'] = $txt['smf252'];
 	$context['sub_template'] = 'merge_done';
Index: smf/Sources/Stats.php
===================================================================
--- smf/Sources/Stats.php	(revision 1047)
+++ smf/Sources/Stats.php	(working copy)
@@ -5,7 +5,7 @@
 * SMF: Simple Machines Forum                                                      *
 * Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                    *
 * =============================================================================== *
-* Software Version:           SMF 1.1                                             *
+* Software Version:           SMF 1.1.6                                           *
 * Software by:                Simple Machines (http://www.simplemachines.org)     *
 * Copyright 2006 by:          Simple Machines LLC (http://www.simplemachines.org) *
 *           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
@@ -387,7 +387,6 @@
 		SELECT ID_MEMBER, realName
 		FROM {$db_prefix}members
 		WHERE ID_MEMBER IN (" . implode(', ', array_keys($members)) . ")
-		GROUP BY ID_MEMBER
 		ORDER BY FIND_IN_SET(ID_MEMBER, '" . implode(',', array_keys($members)) . "')
 		LIMIT 10", __FILE__, __LINE__);
 	$context['top_starters'] = array();
@@ -595,7 +594,7 @@
 			$out .= "Host: www.simplemachines.org\r\n";
 			$out .= "Content-Type: application/x-www-form-urlencoded\r\n";
 			$out .= "Content-Length: $length\r\n\r\n";
-			$out .= "$stats_to_send\r\n"; 
+			$out .= "$stats_to_send\r\n";
 			$out .= "Connection: Close\r\n\r\n";
 			fwrite($fp, $out);
 			fclose($fp);
Index: smf/Sources/Subs-Auth.php
===================================================================
--- smf/Sources/Subs-Auth.php	(revision 1047)
+++ smf/Sources/Subs-Auth.php	(working copy)
@@ -5,9 +5,9 @@
 * SMF: Simple Machines Forum                                                      *
 * Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                    *
 * =============================================================================== *
-* Software Version:           SMF 1.1.3                                           *
+* Software Version:           SMF 1.1.10                                          *
 * Software by:                Simple Machines (http://www.simplemachines.org)     *
-* Copyright 2006 by:          Simple Machines LLC (http://www.simplemachines.org) *
+* Copyright 2006-2009 by:     Simple Machines LLC (http://www.simplemachines.org) *
 *           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
 * Support, News, Updates at:  http://www.simplemachines.org                       *
 ***********************************************************************************
@@ -179,7 +179,7 @@
 		$_SESSION = $oldSessionData;
 
 		// Version 4.3.2 didn't store the cookie of the new session.
-		if (version_compare(PHP_VERSION, '4.3.2') === 0)
+		if (version_compare(PHP_VERSION, '4.3.2') === 0 || (isset($_COOKIE[session_name()]) && $_COOKIE[session_name()] != session_id()))
 			setcookie(session_name(), session_id(), time() + $cookie_length, $cookie_url[1], '', 0);
 
 		$_SESSION['login_' . $cookiename] = $data;
@@ -195,7 +195,7 @@
 		if (headers_sent())
 			return false;
 
-		session_id(strtolower(md5(uniqid(rand(), true))));
+		session_id(strtolower(md5(uniqid(mt_rand(), true))));
 		return true;
 	}
 }
@@ -616,7 +616,8 @@
 	}
 
 	// Generate a random password.
-	$newPassword = substr(preg_replace('/\W/', '', md5(rand())), 0, 10);
+	require_once($sourcedir . '/Subs-Members.php');
+	$newPassword = generateValidationCode();
 	$newPassword_sha1 = sha1(strtolower($user) . $newPassword);
 
 	// Do some checks on the username if needed.
Index: smf/Sources/Subs-Compat.php
===================================================================
--- smf/Sources/Subs-Compat.php	(revision 1047)
+++ smf/Sources/Subs-Compat.php	(working copy)
@@ -5,7 +5,7 @@
 * SMF: Simple Machines Forum                                                      *
 * Open-Source Project Inspired by Zef Hemel (zef@zefhemel.com)                    *
 * =============================================================================== *
-* Software Version:           SMF 1.1.5                                           *
+* Software Version:           SMF 1.1.6                                           *
 * Software by:                Simple Machines (http://www.simplemachines.org)     *
 * Copyright 2006-2007 by:     Simple Machines LLC (http://www.simplemachines.org) *
 *           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
@@ -171,24 +171,5 @@
 	}
 }
 
-// Make sure random means random.
-if (@version_compare(PHP_VERSION, '4.2.0') == -1)
-{
-	function smf_seed_generator()
-	{
-		global $modSettings;
 
-		if (empty($modSettings['rand_seed']))
-		{
-			$modSettings['rand_seed'] = microtime() * 1000000;
-			updateSettings(array('rand_seed' => $modSettings['rand_seed']));
-		}
-		$seed = ($modSettings['rand_seed'] + ((double) microtime() * 1000003)) & 0x7fffffff;
-		srand($seed);
-		// Change the seed?
-		if (rand(1, 250) == 69)
-			updateSettings(array('rand_seed' => rand()));
-	}
-}
-
 ?>
\ No newline at end of file
